Debian Bug report logs - #666688
upload of multi-option enabled coreutils ls (in time for wheezy)

Package: tech-ctte; Maintainer for tech-ctte is Technical Committee <debian-ctte@lists.debian.org>;

Reported by: Joey Hess <joeyh@debian.org>

Date: Sun, 1 Apr 2012 00:03:02 UTC

Severity: normal

Done: Joey Hess <joeyh@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#666688; Package tech-ctte. (Sun, 01 Apr 2012 00:03:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
New Bug report received and forwarded. Copy sent to Technical Committee <debian-ctte@lists.debian.org>. (Sun, 01 Apr 2012 00:03:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: upload of multi-option enabled coreutils ls (in time for wheezy)
Date: Sat, 31 Mar 2012 19:59:24 -0400
[Message part 1 (text/plain, inline)]
Package: tech-ctte
Severity: normal

Dearest members of the Technical Committee,
  I hereby submit to your attention the "coreutils ls options conflict".
I believe the issue is well-known, so I describe it only briefly below;
feel free to ask if you need more information.

ls is missing several key options, notably -y, -e, and -j.
Patches are available for some amount of time now:
http://bugs.debian.org/666198 adds -y
  (necessary for compatability with old shar archives)
http://bugs.debian.org/666244 adds -e
  (entangled directory display option, quite nice)
http://bugs.debian.org/666684 adds -j
  (suitable output format for twitter, cell phones, other 21st century media)

The inclusion of these features in the archive has been one of the goals
of many of us, for many reasons. For many periods of time, the upload of
such a version of coreutils has been held back due to NACK and inaction
by the coreutils maintainer.

The desire to not pointlessly bloat ls with options is good, but then
this is GNU ls, and it already supports
-aAbBcCdDfFgGhHiIklLmnNopqQrRsStTuUvwxXZ1 [1]. The coreutils maintainer
doesn't seem to be able to complete the review in a reasonable time frame.
The situation has escalated to the point that coreutils upstream, who
favors adding at least the crucial -y option as a hidden option (appropriate
given its compatability use case), is in disagreement with the
Debian maintainer.

As anti-DPL[2], I'm worried about two aspects of this issue:

a) The risk of legitimating the fact that by not acting a developer can
   block indefinitely the work of other developers (and possibly of the
   entire project when working on a rather far reaching release goal).

b) The risk of a negative impact on project morale if---due to the
   reason above rather than a legitimate technical reason---we will miss
   the Wheezy multi-ls-option release goal.

I therefore bring before you the issue of whether:

- the coreutils maintainer has the right to block indefinitely accepting
  these options into coreutils ls;

- or rather if other interested parties have the right to override his
  NACK and go ahead with uploads that would allow project-wide testing
  of the multi-ls-option implementation.

Many thanks in advance for your help,
Cheers.

PS I've to point out that timing on this issue is, unfortunately,
   critical. The Wheezy freeze is close and according to the release
   team we're already late wrt the ideal upload date for coreutils.
   The delay is not tech-ctte's fault, of course, but please understand
   that a long decision time on your part would be a de facto decision.
   I'd appreciate if you could reach a decision on this in a timely manner,
   as you've recently done in several other nicely expedited cases.

-- 
-see -shy -jo

[1] A side benefit of filling in the missing gaps is it will allow the
    getopt parameter to be autogenerated, avoiding much complication.
[2] http://kitenet.net/~joey/blog/entry/my_anti-platform/
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#666688; Package tech-ctte. (Sun, 01 Apr 2012 00:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Russ Allbery <rra@debian.org>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>. (Sun, 01 Apr 2012 00:27:03 GMT) Full text and rfc822 format available.

Message #10 received at 666688@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: 666688@bugs.debian.org
Cc: Joey Hess <joeyh@debian.org>
Subject: Re: Bug#666688: upload of multi-option enabled coreutils ls (in time for wheezy)
Date: Sat, 31 Mar 2012 17:24:37 -0700
I have a sneaking suspicion that this may not actually be about what it
says on the tin, but nonetheless, I'll reply to the request as submitted.
I think my reply below also amounts to a commentary on what I suspect is
the underlying issue behind this bug report in that it points out the
substantial differences in this case.

Joey Hess <joeyh@debian.org> writes:

>   I hereby submit to your attention the "coreutils ls options conflict".
> I believe the issue is well-known, so I describe it only briefly below;
> feel free to ask if you need more information.

> ls is missing several key options, notably -y, -e, and -j.
> Patches are available for some amount of time now:
> http://bugs.debian.org/666198 adds -y
>   (necessary for compatability with old shar archives)

This seems interesting but not horribly vital, and doesn't seem like the
sort of place where Debian gains sufficient benefit from diverging from
upstream to warrant patching it ourself.  I'm sure that if upstream
accepted this option, Debian would then pick it up.  Have you contacted
upstream about this option?  I don't see any sign of that in the bug
report.

> http://bugs.debian.org/666244 adds -e
>   (entangled directory display option, quite nice)
> http://bugs.debian.org/666684 adds -j
>   (suitable output format for twitter, cell phones, other 21st century media)

These both pretty obviously should go to upstream and are not places where
Debian should diverge from upstream (what if upstream uses that option for
something else?).  With both of these as well, I don't see any sign in the
bug reports that these have gone to upstream.

> The situation has escalated to the point that coreutils upstream, who
> favors adding at least the crucial -y option as a hidden option
> (appropriate given its compatability use case), is in disagreement with
> the Debian maintainer.

Could you point me at that discussion?  Is it publicly archived somewhere?
It's not in the bug report.  (Bob Proulx is not the GNU coreutils
maintainer.)

> b) The risk of a negative impact on project morale if---due to the
>    reason above rather than a legitimate technical reason---we will miss
>    the Wheezy multi-ls-option release goal.

I'm not familiar with this release goal.  Could you point me at the
previous discussion and general project agreement on this as a release
goal?

-- 
Russ Allbery (rra@debian.org)               <http://www.eyrie.org/~eagle/>




Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#666688; Package tech-ctte. (Sun, 01 Apr 2012 00:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ijackson@chiark.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>. (Sun, 01 Apr 2012 00:51:03 GMT) Full text and rfc822 format available.

Message #15 received at submit@bugs.debian.org (full text, mbox):

From: Ian Jackson <ijackson@chiark.greenend.org.uk>
To: Joey Hess <joeyh@debian.org>, 666688@bugs.debian.org
Cc: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: Re: Bug#666688: upload of multi-option enabled coreutils ls (in time for wheezy)
Date: Sun, 1 Apr 2012 01:47:42 +0100
Joey Hess writes ("Bug#666688: upload of multi-option enabled coreutils ls (in time for wheezy)"):
> ls is missing several key options, notably -y, -e, and -j.

Also, it is unable to read email.  For a long time this serious
deficiency in ls has gone unremedied.  Debian GNU/Linux should take
the lead in the "every program should be able to function as a MUA"
philosophy which the GNU Project once had but has now sadly abandoned,
along with so many other important principles of traditional Unix
(such as the notion that command line utilities should enrich the
excitement in the user's life by crashing randomly when fed bogus
input, and the notion that checking for errors in shell scripts is a
waste of time and should therefore be made difficult if not
impossible).

Joey, sorry for derailing the important issue you raise.  The TC
should consider this with some urgency.  We will get back to you soon,
perhaps as early as April 2014.

Ian.




Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#666688; Package tech-ctte. (Sun, 01 Apr 2012 00:51:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ijackson@chiark.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>. (Sun, 01 Apr 2012 00:51:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#666688; Package tech-ctte. (Sun, 01 Apr 2012 08:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>. (Sun, 01 Apr 2012 08:12:03 GMT) Full text and rfc822 format available.

Message #25 received at 666688@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Russ Allbery <rra@debian.org>, 666688@bugs.debian.org
Subject: Re: Bug#666688: upload of multi-option enabled coreutils ls (in time for wheezy)
Date: Sun, 1 Apr 2012 10:09:51 +0200
Hi,

On Sat, 31 Mar 2012, Russ Allbery wrote:
> I have a sneaking suspicion that this may not actually be about what it
> says on the tin, but nonetheless, I'll reply to the request as submitted.

I suspect an April's fool from a timezone different than the one Joey Hess
lives in :-)

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Pre-order a copy of the Debian Administrator's Handbook and help
liberate it: http://debian-handbook.info/liberation/




Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#666688; Package tech-ctte. (Sun, 01 Apr 2012 08:15:14 GMT) Full text and rfc822 format available.

Acknowledgement sent to Russ Allbery <rra@debian.org>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>. (Sun, 01 Apr 2012 08:15:15 GMT) Full text and rfc822 format available.

Message #30 received at 666688@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: Raphael Hertzog <hertzog@debian.org>
Cc: 666688@bugs.debian.org
Subject: Re: Bug#666688: upload of multi-option enabled coreutils ls (in time for wheezy)
Date: Sun, 01 Apr 2012 01:12:02 -0700
Raphael Hertzog <hertzog@debian.org> writes:
> On Sat, 31 Mar 2012, Russ Allbery wrote:

>> I have a sneaking suspicion that this may not actually be about what it
>> says on the tin, but nonetheless, I'll reply to the request as submitted.

> I suspect an April's fool from a timezone different than the one Joey Hess
> lives in :-)

Yeah, probably.  :)

Even still, though, it seemed like one with a point, so... I guess I will
stand by the counterpoint.

-- 
Russ Allbery (rra@debian.org)               <http://www.eyrie.org/~eagle/>




Reply sent to Joey Hess <joeyh@debian.org>:
You have taken responsibility. (Mon, 02 Apr 2012 18:36:15 GMT) Full text and rfc822 format available.

Notification sent to Joey Hess <joeyh@debian.org>:
Bug acknowledged by developer. (Mon, 02 Apr 2012 18:36:15 GMT) Full text and rfc822 format available.

Message #35 received at 666688-done@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: 666198-done@bugs.debian.org, 666244-done@bugs.debian.org, 666684-done@bugs.debian.org, 666688-done@bugs.debian.org
Cc: Bob Proulx <bob@proulx.com>
Subject: Re: Bug#666198: ls: add -y option
Date: Mon, 2 Apr 2012 14:32:20 -0400
Bob Proulx wrote:
> Joey Hess wrote:
> > This is needed for compatability with an early form of shar archive
> > posted to Usenet in the early 80's. There is valuable historical data
> > to be extracted from these, but they often seem to use this -y option
> > to ls that is not present in modern versions.
> 
> This is an interesting compatibility feature.  As such I agree it has
> some merit although how much I don't know.  Put me down as officially
> abstaining from that point.  However:

This was a set up for
http://kitenet.net/~joey/blog/entry/ls:_the_missing_options/

This article http://article.olduse.net/286@Apur-ee.UUCP about COBOL
was edited to create a fairly convincing historical proof of a ls -y.
I think only fairly convincing because it's unclear why a shar would
ever need to ls files, even back in the 80's!

As to the other options, multiple people agree that -e is nearly almost
useful, although none of us can quite find a reason to use it. My bug
report neglected to mention that ls -eR is very buggy. -j is clearly a joke.

-- 
see shy jo




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 01 May 2012 07:44:12 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 12:24:04 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.